# VariableVerletIntegrator Class Reference

This is an error contolled, variable time step Integrator that simulates a System using the leap-frog Verlet algorithm. More...

Inheritance diagram for VariableVerletIntegrator:

List of all members.

## Public Member Functions

def | getErrorTolerance
| getErrorTolerance(self) -> double
def | setErrorTolerance
| setErrorTolerance(self, double tol)
def | step
| step(self, int steps)
def | stepTo
| stepTo(self, double time)
def | __init__
| __init__(self, double errorTol) -> VariableVerletIntegrator __init__(self, VariableVerletIntegrator other) -> VariableVerletIntegrator
def | __del__
| __del__(self)

## Public Attributes

| this

## Detailed Description

This is an error contolled, variable time step Integrator that simulates a System using the leap-frog Verlet algorithm.

It compares the result of the Verlet integrator to that of an explicit Euler integrator, takes the difference between the two as a measure of the integration error in each time step, and continuously adjusts the step size to keep the error below a specified tolerance. This both improves the stability of the integrator and allows it to take larger steps on average, while still maintaining comparable accuracy to a fixed step size integrator.

It is best not to think of the error tolerance as having any absolute meaning. It is just an adjustable parameter that affects the step size and integration accuracy. You should try different values to find the largest one that produces a trajectory sufficiently accurate for your purposes. 0.001 is often a good starting point.

Unlike a fixed step size Verlet integrator, variable step size Verlet is not symplectic. This means that at a given accuracy level, energy is not as precisely conserved over long time periods. This makes it most appropriate for constant temperate simulations. In constant energy simulations where precise energy conservation over long time periods is important, a fixed step size Verlet integrator may be more appropriate.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(self)

Reimplemented from Integrator.

def __init__ | ( |  | self,
|  |  | args |
| ) |  |  |

__init__(self, double errorTol) -> VariableVerletIntegrator __init__(self, VariableVerletIntegrator other) -> VariableVerletIntegrator

Create a VariableVerletIntegrator.

Parameters:

  | errorTol | the error tolerance

def getErrorTolerance | ( |  | self | ) |

getErrorTolerance(self) -> double

Get the error tolerance.

def setErrorTolerance | ( |  | self,
|  |  | args |
| ) |  |  |

setErrorTolerance(self, double tol)

Set the error tolerance.

def step | ( |  | self,
|  |  | args |
| ) |  |  |

step(self, int steps)

Advance a simulation through time by taking a series of time steps.

Parameters:

  | steps | the number of time steps to take

Reimplemented from Integrator.

def stepTo | ( |  | self,
|  |  | args |
| ) |  |  |

stepTo(self, double time)

Advance a simulation through time by taking a series of steps until a specified time is reached. When this method returns, the simulation time will exactly equal the time which was specified. If you call this method and specify a time that is earlier than the current time, it will return without doing anything.

Parameters:

  | time | the time to which the simulation should be advanced

## Member Data Documentation

this

Reimplemented from Integrator.

The documentation for this class was generated from the following file:

- openmm.py